Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6782)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6783)
@@ -560,5 +560,5 @@
     grok.require('waeup.viewStudent')
     form_fields = grok.AutoFields(IStudentStudyLevel)
-    #grok.template('studylevelpage')
+    grok.template('studylevelpage')
     title = 'Study Level'
     pnav = 4
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt	(revision 6783)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt	(revision 6783)
@@ -0,0 +1,60 @@
+<h2 tal:content="view/label">TITLE</h2>
+
+<table class="zebra">
+<thead>
+</thead>
+<tbody>
+  <tal:block repeat="widget view/widgets">
+    <tr>
+      <td>
+        <label tal:attributes="for widget/name">
+          <span i18n:translate=""
+                         tal:content="widget/label">label</span>:
+        </label>
+      </td>
+      <td class="field" tal:on-error="default">
+        <div class="widget" tal:content="structure widget">
+          <input type="text" />
+        </div>
+      </td>
+    </tr>
+  </tal:block>
+</tbody>
+</table>
+
+<h3>Course Tickets</h3>
+
+<table class="zebra">
+  <thead>
+    <tr>
+      <th>Level</th>
+      <th>Course Code</th>
+      <th>Course Title</th>
+      <th>Department</th>
+      <th>Faculty</th>
+      <th>Credits</th>
+      <th>Mandatory</th>
+      <th>Score</th>
+    </tr>
+  </thead>
+  <tbody>
+    <tr tal:repeat="value context/values">
+      <td tal:content="value/level">LEVEL</td>
+      <td> <a tal:attributes="href value/__name__">
+      <span tal:content="value/code">CODE</span>
+      </a></td>
+      <td tal:content="value/title">TITLE</td>
+      <td tal:content="value/department">DEPARTMENT</td>
+      <td tal:content="value/faculty">FACULTY</td>
+      <td tal:content="value/credits">CREDITS</td>
+      <td tal:content="value/core_or_elective">MANDATORY</td>
+      <td tal:content="value/score">SCORE</td>
+
+    </tr>
+  </tbody>
+</table>
+
+
+<div tal:condition="python: not len(context.keys())">
+There no levels registered yet.
+</div>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6782)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6783)
@@ -213,15 +213,13 @@
 
     """
-    code = Attribute('Course code')
-    title = Attribute('Course title')
-    course_level = Attribute('level of the original course referrer')
+    code = Attribute('code of the original course')
+    title = Attribute('title of the original course')
+    credits = Attribute('credits of the original course')
+    passmark = Attribute('passmark of the original course')
+    semester = Attribute('semester of the original course')
+    faculty = Attribute('faculty of the original course')
+    department = Attribute('department of the original course')
     core_or_elective = Attribute('core_or_elective of the original course referrer')
-
-    credits = schema.Int(
-        title = u'Credits',
-        default = 0,
-        required = False,
-        readonly = False,
-        )
+    level = Attribute('level of the original course referrer')
 
     score = schema.Int(
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py	(revision 6782)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py	(revision 6783)
@@ -52,4 +52,9 @@
                 val.getCourseCode(),
                 val.course.title,
+                val.course.credits,
+                val.course.passmark,
+                val.course.semester,
+                val.course.__parent__.__parent__.__parent__.title,
+                val.course.__parent__.__parent__.title,
                 val.level,
                 val.core_or_elective)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py	(revision 6782)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py	(revision 6783)
@@ -60,13 +60,25 @@
     student to attend the course. Lecturers will enter scores and more at
     the end of the term.
+
+    A course ticket contains a copy of the original course and
+    course referrer data. If the courses and/or their referrers are removed, the
+    corresponding tickets remain unchanged. So we do not need any event
+    triggered actions on course tickets.
     """
     grok.implements(ICourseTicket, IStudentNavigation)
     grok.provides(ICourseTicket)
 
-    def __init__(self, code, title, course_level, core_or_elective):
+    def __init__(self, code, title, credits,
+        passmark, semester, faculty, department, level, core_or_elective):
+
         super(CourseTicket, self).__init__()
         self.title = title
         self.code = code
-        self.course_level = course_level
+        self.faculty = faculty
+        self.department = department
+        self.level = level
+        self.credits = credits
+        self.passmark = passmark
+        self.semester = semester
         self.core_or_elective = core_or_elective
         return
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_student.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_student.py	(revision 6782)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_student.py	(revision 6783)
@@ -37,5 +37,6 @@
         self.studycourse = StudentStudyCourse()
         self.studylevel = StudentStudyLevel()
-        self.courseticket = CourseTicket('CERT', 'Title', 100, True)
+        self.courseticket = CourseTicket('CERT', 'Title', 100, 10, 40, 1,
+            'Faculty', 'Department', True)
         self.payments = StudentPayments()
         self.accommodation = StudentAccommodation()