Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6801)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6802)
@@ -661,5 +661,5 @@
         course = data['course']
         ticket.core_or_elective = data['core_or_elective']
-        ticket.level = self.context.level
+        ticket.automatic = False
         ticket.code = course.code
         ticket.title = course.title
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelmanagepage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelmanagepage.pt	(revision 6801)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelmanagepage.pt	(revision 6802)
@@ -62,7 +62,6 @@
     <tr>
       <th>&nbsp;</th>
-      <th>Level</th>
-      <th>Course Code</th>
-      <th>Course Title</th>
+      <th>Code</th>
+      <th>Title</th>
       <th>Department</th>
       <th>Faculty</th>
@@ -70,4 +69,5 @@
       <th>Mandatory</th>
       <th>Score</th>
+      <th>Automatic</th>
     </tr>
   </thead>
@@ -78,5 +78,4 @@
   		  tal:attributes="value value/__name__" />
       </td>
-      <td tal:content="value/level">LEVEL</td>
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/code">CODE</span>
@@ -88,4 +87,5 @@
       <td tal:content="value/core_or_elective">MANDATORY</td>
       <td tal:content="value/score">SCORE</td>
+      <td tal:content="value/automatic">AUTOMATIC</td>
     </tr>
   </tbody>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt	(revision 6801)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studylevelpage.pt	(revision 6802)
@@ -28,7 +28,6 @@
   <thead>
     <tr>
-      <th>Level</th>
-      <th>Course Code</th>
-      <th>Course Title</th>
+      <th>Code</th>
+      <th>Title</th>
       <th>Department</th>
       <th>Faculty</th>
@@ -36,9 +35,9 @@
       <th>Mandatory</th>
       <th>Score</th>
+      <th>Automatic</th>
     </tr>
   </thead>
   <tbody>
     <tr tal:repeat="value context/values">
-      <td tal:content="value/level">LEVEL</td>
       <td> <a tal:attributes="href value/__name__">
       <span tal:content="value/code">CODE</span>
@@ -50,5 +49,5 @@
       <td tal:content="value/core_or_elective">MANDATORY</td>
       <td tal:content="value/score">SCORE</td>
-
+      <td tal:content="value/automatic">AUTOMATIC</td>
     </tr>
   </tbody>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6801)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6802)
@@ -238,5 +238,5 @@
     faculty = Attribute('faculty of the original course')
     department = Attribute('department of the original course')
-    level = Attribute('level of the original course referrer')
+    automatic = Attribute('automatical creation of ticket')
 
     core_or_elective = schema.Bool(
@@ -254,11 +254,4 @@
         )
 
-    grade = schema.TextLine(
-        title = u'Grade',
-        default = u'',
-        required = False,
-        readonly = True,
-        )
-
 class ICourseTicketAdd(ICourseTicket):
     """An interface for adding course tickets
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py	(revision 6801)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/studycourse.py	(revision 6802)
@@ -53,5 +53,5 @@
             ticket = CourseTicket()
             ticket.code = val.getCourseCode()
-            ticket.level = val.level
+            ticket.automatic = True
             ticket.core_or_elective = val.core_or_elective
             ticket.title = val.course.title
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py	(revision 6801)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/studylevel.py	(revision 6802)
@@ -74,5 +74,5 @@
         super(CourseTicket, self).__init__()
         self.code = None
-        self.level = None
+        self.automatic = None
         self.title = None
         self.faculty = None