Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/layout.py	(revision 6818)
@@ -161,5 +161,5 @@
         """
         if IStudentNavigation.providedBy(self.context):
-            return self.context.getStudent().name
+            return self.context.getStudent().fullname
         return
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/authentication.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/authentication.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/authentication.py	(revision 6818)
@@ -52,5 +52,5 @@
     @property
     def title(self):
-        return self.context.name
+        return self.context.fullname
 
     @property
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser.py	(revision 6818)
@@ -79,4 +79,12 @@
     title = u'Students'
 
+class StudentBreadcrumb(Breadcrumb):
+    """A breadcrumb for the student container.
+    """
+    grok.context(IStudent)
+
+    def title(self):
+        return self.context.fullname
+
 class SudyCourseBreadcrumb(Breadcrumb):
     """A breadcrumb for the student study course.
@@ -292,5 +300,5 @@
     @property
     def label(self):
-        return '%s: Base Data' % self.context.name
+        return '%s: Base Data' % self.context.fullname
 
     @property
@@ -393,5 +401,5 @@
     @property
     def label(self):
-        return '%s: Clearance Data' % self.context.name
+        return '%s: Clearance Data' % self.context.fullname
 
 class StudentClearanceManageActionButton(ManageActionButton):
@@ -437,5 +445,5 @@
     @property
     def label(self):
-        return '%s: Personal Data' % self.context.name
+        return '%s: Personal Data' % self.context.fullname
 
 class StudentPersonalManageActionButton(ManageActionButton):
@@ -476,5 +484,5 @@
     @property
     def label(self):
-        return '%s: Study Course' % self.context.__parent__.name
+        return '%s: Study Course' % self.context.__parent__.fullname
 
 class StudyCourseManageActionButton(ManageActionButton):
@@ -573,5 +581,5 @@
     def label(self):
         return '%s: Study Level %s' % (
-            self.context.getStudent().name,self.context.level_title)
+            self.context.getStudent().fullname,self.context.level_title)
 
     @property
@@ -707,5 +715,5 @@
     def label(self):
         return '%s: Course Ticket %s' % (
-            self.context.getStudent().name,self.context.code)
+            self.context.getStudent().fullname,self.context.code)
 
 class CourseTicketManageActionButton(ManageActionButton):
@@ -753,5 +761,5 @@
     @property
     def label(self):
-        return '%s: Payments' % self.context.__parent__.name
+        return '%s: Payments' % self.context.__parent__.fullname
 
 class AccommodationDisplayFormPage(WAeUPDisplayFormPage):
@@ -768,5 +776,5 @@
     @property
     def label(self):
-        return '%s: Accommodation Data' % self.context.__parent__.name
+        return '%s: Accommodation Data' % self.context.__parent__.fullname
 
 class StudentHistoryPage(WAeUPPage):
@@ -782,5 +790,5 @@
     @property
     def label(self):
-        return '%s: History' % self.context.name
+        return '%s: History' % self.context.fullname
 
 # Pages for students only
@@ -805,5 +813,5 @@
 
     def __init__(self, context):
-        self.name = context.name
+        self.name = context.fullname
         self.password_repeat = context.password
         self.context = context
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containerpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containerpage.pt	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/containerpage.pt	(revision 6818)
@@ -9,5 +9,5 @@
   <select name="searchtype">
     <option value="student_id">with id</option>
-    <option value="name">with name</option>
+    <option value="fullname">with name</option>
     <option value="reg_number">with registration number</option>
     <option value="matric_number">with matriculation number</option>
@@ -23,5 +23,5 @@
     <input type="hidden" name="old_searchtype"
          tal:attributes="value view/searchtype" />
-    <table class="display dataTableManage">
+    <table class="display dataTable">
       <thead>
       <tr>
@@ -29,5 +29,5 @@
         <th>Registration Number</th>
         <th>Matriculation Number</th>
-        <th>Name</th>
+        <th>Fullname</th>
       </tr>
       </thead>
@@ -43,5 +43,5 @@
           <span tal:content="item/matric_number">9999999</span></a>
         </td>
-        <td tal:content="item/name">Bob</td>
+        <td tal:content="item/fullname">Bob</td>
       </tr>
       </tbody>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studentaddpage.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studentaddpage.pt	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/browser_templates/studentaddpage.pt	(revision 6818)
@@ -7,7 +7,7 @@
     <tbody>
       <tr>
-    	<td><label for="form.name">Full Name:</label></td>
+    	<td><label for="form.fullname">Full Name:</label></td>
     	<td>
-         <input name="form.name" type="text" size="30" maxlength="30"
+         <input name="form.fullname" type="text" size="30" maxlength="30"
                 value="" />
     	</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/catalog.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/catalog.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/catalog.py	(revision 6818)
@@ -18,5 +18,5 @@
 
     student_id = index.Field(attribute='student_id')
-    name = index.Text(attribute='name')
+    fullname = index.Text(attribute='fullname')
     reg_number = index.Field(attribute='reg_number')
     matric_number = index.Field(attribute='matric_number')
@@ -34,5 +34,5 @@
         self.url = view.url(context)
         self.student_id = context.student_id
-        self.name = context.name
+        self.fullname = context.fullname
         self.reg_number = context.reg_number
         self.matric_number = context.matric_number
@@ -41,5 +41,5 @@
 def search(query=None, searchtype=None, view=None):
     hitlist = []
-    if searchtype in ('name',):
+    if searchtype in ('fullname',):
         results = Query().searchResults(
             Text(('students_catalog', searchtype), query))
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/interfaces.py	(revision 6818)
@@ -103,7 +103,7 @@
         )
 
-    name = schema.TextLine(
+    fullname = schema.TextLine(
         title = u'Full Name',
-        default = u'Nobody',
+        default = None,
         required = True,
         )
@@ -111,5 +111,5 @@
     reg_number = TextLineChoice(
         title = u'Registration Number',
-        #default = u'',
+        default = None,
         required = True,
         readonly = False,
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_authentication.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_authentication.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_authentication.py	(revision 6818)
@@ -65,5 +65,5 @@
 class FakeStudent(object):
     student_id = 'test_stud'
-    name = 'Test User'
+    fullname = 'Test User'
     password = None
 
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_browser.py	(revision 6818)
@@ -69,7 +69,7 @@
         setSite(app)
 
-        # Add student with subobjects (done by addStudent)
+        # Add student with subobjects
         student = Student()
-        student.name = u'Anna Tester'
+        student.fullname = u'Anna Tester'
         student.reg_number = u'123'
         student.matric_number = u'234'
@@ -186,5 +186,5 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.url, self.add_student_path)
-        self.browser.getControl(name="form.name").value = 'Bob Tester'
+        self.browser.getControl(name="form.fullname").value = 'Bob Tester'
         self.browser.getControl("Create student record").click()
         self.assertTrue('Student record created' in self.browser.contents)
@@ -213,5 +213,5 @@
         self.browser.getControl("Search").click()
         self.assertTrue('Empty search string' in self.browser.contents)
-        self.browser.getControl(name="searchtype").value = ['name']
+        self.browser.getControl(name="searchtype").value = ['fullname']
         self.browser.getControl(name="searchterm").value = 'Anna Tester'
         self.browser.getControl("Search").click()
@@ -255,5 +255,5 @@
         # Managers can edit base data and fire transitions
         self.browser.getControl(name="transition").value = ['admit']
-        self.browser.getControl(name="form.name").value = 'John Tester'
+        self.browser.getControl(name="form.fullname").value = 'John Tester'
         self.browser.getControl(name="form.reg_number").value = '345'
         self.browser.getControl(name="password").value = 'secret'
@@ -429,5 +429,5 @@
         student = Student()
         student.reg_number = u'123456'
-        student.name = u'Klaus Tester'
+        student.fullname = u'Klaus Tester'
         test_student_id = self.app['students'].addStudent(student)
         setpassword_path = 'http://localhost/app/setpassword'
Index: main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_catalog.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_catalog.py	(revision 6816)
+++ main/waeup.sirp/trunk/src/waeup/sirp/students/tests/test_catalog.py	(revision 6818)
@@ -44,5 +44,5 @@
         # Create students
         student = Student()
-        student.name = u'Bob Tester'
+        student.fullname = u'Bob Tester'
         student.student_id = u'A123456'
         self.app['students'][student.student_id] = student
@@ -74,5 +74,5 @@
         # We can find a certain name
         cat = queryUtility(ICatalog, name='students_catalog')
-        results = cat.searchResults(name='Bob Tester')
+        results = cat.searchResults(fullname='Bob Tester')
         results = [x for x in results] # Turn results generator into list
         assert len(results) == 1