Index: main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.py	(revision 6819)
+++ main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.py	(revision 6824)
@@ -102,13 +102,17 @@
     def applyMapping(self, row, mapping):
         """Apply mapping to a row of CSV data.
+
         """
         result = dict()
         for key, replacement in mapping.items():
+            if replacement == u'--IGNORE--':
+                # Skip ignored columns in failed and finished data files.
+                continue
             result[replacement] = row[key]
         return result
 
     def getMapping(self, path, headerfields, mode):
-        """Get a mapping from CSV file headerfields to actually used
-           fieldnames.
+        """Get a mapping from CSV file headerfields to actually used fieldnames.
+
         """
         result = dict()
@@ -117,6 +121,9 @@
         for num, field in enumerate(headerfields):
             if field not in self.location_fields and mode == 'remove':
-                # Ignore non-location fields when removing...
-                field = '--IGNORE--'
+                # Skip non-location fields when removing.
+                continue
+            if field == u'--IGNORE--':
+                # Skip ignored columns in failed and finished data files.
+                continue
             result[raw_header[num]] = field
         return result
@@ -250,5 +257,5 @@
                 conv_warnings = self.stringFromErrs(errs, inv_errs)
                 self.writeFailedRow(
-                    failed_writer, raw_row, conv_warnings)
+                    failed_writer, string_row, conv_warnings)
                 continue
             row.update(conv_dict)
@@ -258,5 +265,5 @@
                     num_warns += 1
                     self.writeFailedRow(
-                        failed_writer, raw_row,
+                        failed_writer, string_row,
                         "Not all parents do exist yet. Skipping")
                     continue
@@ -264,5 +271,5 @@
                     num_warns += 1
                     self.writeFailedRow(
-                        failed_writer, raw_row,
+                        failed_writer, string_row,
                         "This object already exists in the same container. Skipping.")
                     continue
@@ -275,5 +282,5 @@
                     num_warns += 1
                     self.writeFailedRow(
-                        failed_writer, raw_row,
+                        failed_writer, string_row,
                         "%s Skipping." % error.message)
                     continue
@@ -282,5 +289,5 @@
                     num_warns += 1
                     self.writeFailedRow(
-                        failed_writer, raw_row,
+                        failed_writer, string_row,
                         "Cannot remove: no such entry.")
                     continue
@@ -291,5 +298,5 @@
                     num_warns += 1
                     self.writeFailedRow(
-                        failed_writer, raw_row,
+                        failed_writer, string_row,
                         "Cannot update: no such entry.")
                     continue
Index: main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.txt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.txt	(revision 6819)
+++ main/waeup.sirp/trunk/src/waeup/sirp/utils/batching.txt	(revision 6824)
@@ -352,5 +352,5 @@
 
 If something goes wrong during processing, the respective --IGNORE--
-cols will be populated correctly in the resulting pending file:
+cols won't be populated  in the resulting pending file:
 
     >>> result = processor.doImport('newcomers.csv', ['name', 'dinoports',
@@ -361,12 +361,10 @@
 
     >>> print open(result[3], 'rb').read()
-    --IGNORE--,name,--IGNORE--,dinoports,--ERRORS--
-    Barney,Barneys Home,1,2,This object already exists in the same container. Skipping.
-    Wilma,Wilmas Asylum,1,1,This object already exists in the same container. Skipping.
-    Fred,Freds Dinoburgers,0,10,This object already exists in the same container. Skipping.
-    Joey,Joeys Drive-in,0,110,This object already exists in the same container. Skipping.
-
-The first ignored column ('owner') provides different contents than
-the second one ('taxpayer').
+    name,dinoports,--ERRORS--
+    Barneys Home,2,This object already exists in the same container. Skipping.
+    Wilmas Asylum,1,This object already exists in the same container. Skipping.
+    Freds Dinoburgers,10,This object already exists in the same container. Skipping.
+    Joeys Drive-in,110,This object already exists in the same container. Skipping.
+
 
 Clean up: