Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport1page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport1page.pt	(revision 6807)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport1page.pt	(revision 6826)
@@ -15,14 +15,14 @@
     <tbody>
       <tr tal:repeat="file view/getFiles"
-	  tal:attributes="class python: repeat['file'].odd() and 'odd' or ''">
-	<td>
-	  <button type="submit" name="select"
-		  tal:attributes="value file/name"
-		  >Select</button>
-	</td>
-	<td tal:content="file/name">Filename.csv</td>
-	<td tal:content="python: file.lines - 1">12</td>
-	<td tal:content="file/size">123 Bytes</td>
-	<td tal:content="file/getDate">1.1.1970</td>
+      tal:attributes="class python: repeat['file'].odd() and 'odd' or ''">
+        <td>
+          <button type="submit" name="select"
+            tal:attributes="value file/name"
+            >Select</button>
+        </td>
+        <td tal:content="file/name">Filename.csv</td>
+        <td tal:content="python: file.lines - 1">12</td>
+        <td tal:content="file/size">123 Bytes</td>
+        <td tal:content="file/getDate">1.1.1970</td>
       </tr>
     </tbody>
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport2page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport2page.pt	(revision 6807)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport2page.pt	(revision 6826)
@@ -1,78 +1,61 @@
-<h2>Process CSV file</h2>
-<h3>Step 2</h3>
-
+<h2>Process CSV file</h2><h3>Step 2</h3>
 <form method="POST">
-  <p>
-    <b>File:</b> <span tal:content="view/filename">Filename.csv</span>
-    <input type="hidden" name="filename"
-	   tal:attributes="value view/filename" />
+  <p> <b>File:</b>
+    <span tal:content="view/filename">Filename.csv
+    </span>
+    <input type="hidden" name="filename"  tal:attributes="value view/filename" />
   </p>
-  <p>
-    Please select a file-processor and a processing-mode from the 
-    selections below:
+  <p> Please select a file-processor and a processing-mode from the  selections below:
   </p>
-
   <div>
     <table style="border: 1px solid #000;"
-	   tal:define="body view/getPreviewBody;
-		       headers view/getPreviewHeader;
-		       fieldnum python: len(headers)">
+            tal:define="body view/getPreviewBody;
+                        headers view/getPreviewHeader;
+                        fieldnum python: len(headers)">
       <thead>
-	<tr style="border: 1px solid #ccc;">
-	  <th style="border: 1px solid #888;"
-	      tal:repeat="headerfield headers"
-	      tal:content="headerfield">
-	    headerfield
-	  </th>
-	</tr>
+        <tr style="border: 1px solid #ccc;">
+          <th style="border: 1px solid #888;"
+              tal:repeat="headerfield headers"
+              tal:content="headerfield"> headerfield
+          </th>
+        </tr>
       </thead>
       <tbody>
-	<tr tal:repeat="row body"
-	    tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
-	    style="border: 1px solid #000;">
-	  <td tal:repeat="value row"
-	      tal:content="value"
-	      style="border: 1px solid #000;">
-	    value
-	  </td>
-	</tr>
+        <tr tal:repeat="row body"
+            tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
+            style="border: 1px solid #000;">
+          <td tal:repeat="value row"
+              tal:content="value"  style="border: 1px solid #000;"> value  </td>
+        </tr>
       </tbody>
     </table>
   </div>
-
-  <div>
-    <b>Processor:</b>
-
+  <div> <b>Processor:</b>
     <select name="importer">
       <option tal:repeat="importer view/getImporters"
-	      tal:attributes="value importer/name;
-			      selected python: importer['name'] == view.importer and 'selected' or ''"
-	      tal:content="importer/title">
-	Some Importer
+          tal:attributes="value importer/name;
+              selected python: importer['name'] == view.importer and 'selected' or ''"
+          tal:content="importer/title"> Some Importer
       </option>
     </select>
-
   </div>
-
-  <p>&nbsp;</p>
-
-  <div>
-    <b>Mode:</b>
-
+  <p>&nbsp;
+  </p>
+  <div> <b>Mode:</b>
     <input type="radio" name="mode" value="create" checked="checked"
-	   tal:attributes="checked python: view.mode == 'create' and 'checked' or '';
-			   disabled python: view.mode != 'create' and view.mode_locked and 'disabled' or ''" /> Create
-    &nbsp;&nbsp;
+       tal:attributes="checked python: view.mode == 'create' and 'checked' or '';
+        disabled python: view.mode != 'create' and view.mode_locked and 'disabled' or ''" />
+        Create  &nbsp;&nbsp;
     <input type="radio" name="mode" value="update"
-	   tal:attributes="checked python: view.mode == 'update' and 'checked' or '';
-			   disabled python: view.mode != 'update' and view.mode_locked and 'disabled' or ''" /> Update
-    &nbsp;&nbsp;
+       tal:attributes="checked python: view.mode == 'update' and 'checked' or '';
+        disabled python: view.mode != 'update' and view.mode_locked and 'disabled' or ''" />
+        Update  &nbsp;&nbsp;
     <input type="radio" name="mode" value="remove"
-	   tal:attributes="checked python: view.mode == 'remove' and 'checked' or '';
-			   disabled python: view.mode != 'remove' and view.mode_locked and 'disabled' or ''" /> Remove
-
-    <p>&nbsp;</p>
+       tal:attributes="checked python: view.mode == 'remove' and 'checked' or '';
+        disabled python: view.mode != 'remove' and view.mode_locked and 'disabled' or ''" />
+        Remove
+    <p>&nbsp;
+    </p>
   </div>
-
   <input type="submit" name="cancel" value="Cancel" />
   <input type="submit" name="back1" value="Back to step 1" />
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport3page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport3page.pt	(revision 6807)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport3page.pt	(revision 6826)
@@ -11,5 +11,5 @@
     <b>File:</b> <span tal:content="view/filename">Filename.csv</span>
     <input type="hidden" name="filename"
-	   tal:attributes="value view/filename" />
+     tal:attributes="value view/filename" />
   </p>
   <p>
@@ -17,5 +17,5 @@
     <span tal:content="view/importer/name">Importer Name</span>
     <input type="hidden" name="importer"
-	   tal:attributes="value view/importer/util_name" />
+     tal:attributes="value view/importer/util_name" />
   </p>
   <p>
@@ -23,20 +23,17 @@
     <span tal:content="view/mode">mode</span>
     <input type="hidden" name="mode"
-	   tal:attributes="value view/mode" />
+     tal:attributes="value view/mode" />
   </p>
 
   <div>
-    <div class="alert error ui-state-error"
-	 tal:condition="warnings">
+    <div class="alert error ui-state-error" tal:condition="warnings">
       <span class="ui-icon ui-icon-alert">A</span>
       Current settings will give the follwing warnings, when importing:
-      <div tal:repeat="warning warnings" 
-	   tal:content="warning">
-	Warning messages
+      <div tal:repeat="warning warnings" tal:content="warning">
+          Warning messages
       </div>
     </div>
 
-    <div class="alert notice ui-state-info"
-	 tal:condition="not: warnings">
+    <div class="alert notice ui-state-info" tal:condition="not: warnings">
       <span class="ui-icon ui-icon-info">A</span>
       Header fields OK
@@ -47,45 +44,45 @@
   <div>
     <table style="border: 1px solid #000;"
-	   tal:define="body view/getPreviewBody;
-		       headers view/headerfields;
-		       fieldnum python: len(headers)">
+     tal:define="body view/getPreviewBody;
+           headers view/headerfields;
+           fieldnum python: len(headers)">
       <thead>
-	<tr style="border: 1px solid #ccc;">
-	  <th style="border: 1px solid #888;"
-	      tal:repeat="headerfield headers"
-	      tal:content="headerfield">
-	    headerfield
-	  </th>
-	</tr>
-	<tr style="border: 1px solid #ccc;">
-	  <th style="border: 1px solid #888; text-align=center;"
-	      tal:repeat="headerfield headers">
-	    <i>change to:</i>
-	  </th>
-	</tr>
-	<tr style="border: 1px solid #ccc;">
-	  <th style="border: 1px solid #888;"
-	      tal:repeat="headerfield headers">
-	    <select name="headerfield">
-	      <option tal:repeat="opt view/getPossibleHeaders"
-		      tal:attributes="value opt/value;
-				      selected python: opt['value']==headerfield and 'selected' or '';"
-		      tal:content="opt/title">
-		new_header_name
-	      </option>
-	    </select>
-	  </th>
-	</tr>
-      </thead>
-      <tbody>
-	<tr tal:repeat="row body"
-	    tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
-	    style="border: 1px solid #000;">
-	  <td tal:repeat="value row"
-	      tal:content="value"
-	      style="border: 1px solid #000;">
-	    value
-	  </td>
-	</tr>
+        <tr style="border: 1px solid #ccc;">
+          <th style="border: 1px solid #888;"
+              tal:repeat="headerfield headers"
+              tal:content="headerfield">
+            headerfield
+          </th>
+        </tr>
+        <tr style="border: 1px solid #ccc;">
+          <th style="border: 1px solid #888; text-align=center;"
+              tal:repeat="headerfield headers">
+            <i>change to:</i>
+          </th>
+        </tr>
+        <tr style="border: 1px solid #ccc;">
+          <th style="border: 1px solid #888;"
+              tal:repeat="headerfield headers">
+            <select name="headerfield">
+              <option tal:repeat="opt view/getPossibleHeaders"
+                tal:attributes="value opt/value;
+                  selected python: opt['value']==headerfield and 'selected' or '';"
+                tal:content="opt/title">
+                new_header_name
+              </option>
+            </select>
+          </th>
+        </tr>
+            </thead>
+            <tbody>
+        <tr tal:repeat="row body"
+            tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
+            style="border: 1px solid #000;">
+          <td tal:repeat="value row"
+              tal:content="value"
+              style="border: 1px solid #000;">
+            value
+          </td>
+        </tr>
       </tbody>
     </table>
@@ -99,5 +96,5 @@
   <input type="submit" name="back2" value="Back to step 2" />
   <input tal:attributes="disabled python: len(warnings) and 'disabled' or ''"
-	 type="submit" name="proceed" value="Perform import..." />
+   type="submit" name="proceed" value="Perform import..." />
 
 </form>
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport4page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport4page.pt	(revision 6807)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport4page.pt	(revision 6826)
@@ -17,5 +17,5 @@
 <form method="POST">
   <input tal:condition="view/warn_num"
-	 type="submit" name="back" value="Back to step 3" />
+    type="submit" name="back" value="Back to step 3" />
   <input type="submit" name="finish" value="Back to data center" />
   <input type="submit" name="showlog" value="View processing log" />