Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport1page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport1page.pt	(revision 6828)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport1page.pt	(revision 6829)
@@ -18,6 +18,5 @@
         <td>
           <button type="submit" name="select"
-            tal:attributes="value file/name"
-            >Select</button>
+            tal:attributes="value file/name">Select</button>
         </td>
         <td tal:content="file/name">Filename.csv</td>
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport2page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport2page.pt	(revision 6828)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport2page.pt	(revision 6829)
@@ -1,18 +1,20 @@
-<h2>Process CSV file</h2><h3>Step 2</h3>
+<h2>Process CSV file</h2>
+<h3>Step 2</h3>
 <form method="POST">
-  <p> <b>File:</b>
+  <p>
+    <b>File:</b>
     <span tal:content="view/filename">Filename.csv
     </span>
     <input type="hidden" name="filename"  tal:attributes="value view/filename" />
   </p>
-  <p> Please select a file-processor and a processing-mode from the  selections below:
+  <p> Please select a file-processor and a processing-mode from the selections below:
   </p>
   <div>
-    <table style="border: 1px solid #000;"
-            tal:define="body view/getPreviewBody;
+    <table class = "zebra"
+           tal:define="body view/getPreviewBody;
                         headers view/getPreviewHeader;
                         fieldnum python: len(headers)">
       <thead>
-        <tr style="border: 1px solid #ccc;">
+        <tr>
           <th style="border: 1px solid #888;"
               tal:repeat="headerfield headers"
@@ -22,9 +24,9 @@
       </thead>
       <tbody>
-        <tr tal:repeat="row body"
-            tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
-            style="border: 1px solid #000;">
+        <tr tal:repeat="row body">
           <td tal:repeat="value row"
-              tal:content="value"  style="border: 1px solid #000;"> value  </td>
+              tal:content="value"
+              style="border: 1px solid #000;"> value
+          </td>
         </tr>
       </tbody>
@@ -60,4 +62,5 @@
   <input type="submit" name="cancel" value="Cancel" />
   <input type="submit" name="back1" value="Back to step 1" />
-  <input type="submit" name="proceed" value="Proceed to step 3..." />
+  <input tal:attributes="disabled python: view.getWarnings() and 'disabled' or ''"
+    type="submit" name="proceed" value="Proceed to step 3..." />
 </form>
Index: main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport3page.pt
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport3page.pt	(revision 6828)
+++ main/waeup.sirp/trunk/src/waeup/sirp/browser/templates/datacenterimport3page.pt	(revision 6829)
@@ -1,13 +1,11 @@
 <h2>Process CSV file</h2>
 <h3>Step 3</h3>
-<div tal:define="warnings view/getWarnings">
 <form>
-
   <p>
     Eventually modify headerfields of import file below.
   </p>
-
   <p>
-    <b>File:</b> <span tal:content="view/filename">Filename.csv</span>
+    <b>File:</b>
+    <span tal:content="view/filename">Filename.csv</span>
     <input type="hidden" name="filename"
      tal:attributes="value view/filename" />
@@ -25,28 +23,15 @@
      tal:attributes="value view/mode" />
   </p>
-
+  <div class="alert notice ui-state-info" tal:condition="not: view/getWarnings">
+    <span class="ui-icon ui-icon-info">A</span>
+    Header fields OK
+  </div>
   <div>
-    <div class="alert error ui-state-error" tal:condition="warnings">
-      <span class="ui-icon ui-icon-alert">A</span>
-      Current settings will give the follwing warnings, when importing:
-      <div tal:repeat="warning warnings" tal:content="warning">
-          Warning messages
-      </div>
-    </div>
-
-    <div class="alert notice ui-state-info" tal:condition="not: warnings">
-      <span class="ui-icon ui-icon-info">A</span>
-      Header fields OK
-    </div>
-  </div>
-
-
-  <div>
-    <table style="border: 1px solid #000;"
+    <table class = "zebra"
      tal:define="body view/getPreviewBody;
            headers view/headerfields;
            fieldnum python: len(headers)">
       <thead>
-        <tr style="border: 1px solid #ccc;">
+        <tr>
           <th style="border: 1px solid #888;"
               tal:repeat="headerfield headers"
@@ -55,5 +40,5 @@
           </th>
         </tr>
-        <tr style="border: 1px solid #ccc;">
+        <tr>
           <th style="border: 1px solid #888; text-align=center;"
               tal:repeat="headerfield headers">
@@ -61,5 +46,5 @@
           </th>
         </tr>
-        <tr style="border: 1px solid #ccc;">
+        <tr>
           <th style="border: 1px solid #888;"
               tal:repeat="headerfield headers">
@@ -74,9 +59,7 @@
           </th>
         </tr>
-            </thead>
-            <tbody>
-        <tr tal:repeat="row body"
-            tal:attributes="class python: repeat['row'].odd() and 'odd' or 'even'"
-            style="border: 1px solid #000;">
+      </thead>
+      <tbody>
+        <tr tal:repeat="row body">
           <td tal:repeat="value row"
               tal:content="value"
@@ -89,5 +72,4 @@
   </div>
 
-
   <input type="submit" name="cancel" value="Cancel" />
   <input type="reset" name="reset" value="Reset" />
@@ -95,7 +77,5 @@
   <br />
   <input type="submit" name="back2" value="Back to step 2" />
-  <input tal:attributes="disabled python: len(warnings) and 'disabled' or ''"
+  <input tal:attributes="disabled python: view.getWarnings() and 'disabled' or ''"
    type="submit" name="proceed" value="Perform import..." />
-
 </form>
-</div>