Index: /main/waeup.sirp/trunk/src/waeup/sirp/app.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/app.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/app.py	(revision 6839)
@@ -73,5 +73,5 @@
 
 @grok.subscribe(University, grok.IObjectAddedEvent)
-def handle_university_add(app, event):
+def handle_university_added(app, event):
     app.logger.info('University `%s` added.' % getattr(app, '__name__', None))
     return
Index: /main/waeup.sirp/trunk/src/waeup/sirp/authentication.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/authentication.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/authentication.py	(revision 6839)
@@ -172,5 +172,5 @@
 
 @grok.subscribe(IUserAccount, grok.IObjectRemovedEvent)
-def handle_account_removal(account, event):
+def handle_account_removed(account, event):
     """When an account is removed, local roles might have to be deleted.
     """
Index: /main/waeup.sirp/trunk/src/waeup/sirp/students/student.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/students/student.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/students/student.py	(revision 6839)
@@ -96,5 +96,5 @@
 
 @grok.subscribe(IStudent, grok.IObjectAddedEvent)
-def addStudentHandler(student, event):
+def handle_student_added(student, event):
     """If a student is added all subcontainers are automatically added
     and the transition create is fired. The latter produces a logging message.
@@ -118,5 +118,5 @@
 
 @grok.subscribe(IStudent, grok.IObjectRemovedEvent)
-def removedStudentHandler(student, event):
+def handle_student_removed(student, event):
     """If a student is removed a message is logged.
     """
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/catalog.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/catalog.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/catalog.py	(revision 6839)
@@ -48,5 +48,5 @@
 
 @grok.subscribe(ICourse, grok.IObjectAddedEvent)
-def handleCourseAdd(obj, event):
+def handle_course_added(obj, event):
     """Index an added course with the local catalog.
 
@@ -71,5 +71,5 @@
 
 @grok.subscribe(ICourse, grok.IObjectAddedEvent)
-def handleCertificateAdd(obj, event):
+def handle_certificate_added(obj, event):
     """Index an added certificate with the local catalog.
 
@@ -86,5 +86,5 @@
 
 @grok.subscribe(ICertificateCourse, grok.IObjectAddedEvent)
-def handleCertificateCourseAdd(obj, event):
+def handlecertificatecourse_added(obj, event):
     """Index an added certificatecourse with the local catalog.
 
@@ -101,5 +101,5 @@
 
 @grok.subscribe(IDepartment, grok.IObjectRemovedEvent)
-def handleDepartmentRemoval(obj, event):
+def handle_department_removed(obj, event):
     """Clear courses and certificates when a department is killed.
     """
Index: /main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/university/certificate.py	(revision 6839)
@@ -97,5 +97,5 @@
 
 @grok.subscribe(ICourse, grok.IObjectRemovedEvent)
-def removedCourseHandler(course, event):
+def handle_course_removed(course, event):
     """If a course is deleted, we make sure that also referrers in a
        certificatecontainer are removed.
Index: /main/waeup.sirp/trunk/src/waeup/sirp/users.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/users.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/users.py	(revision 6839)
@@ -64,5 +64,5 @@
 
 @grok.subscribe(Interface, grok.IObjectRemovedEvent)
-def handle_local_roles_on_obj_removal(obj, event):
+def handle_local_roles_on_obj_removed(obj, event):
     try:
         role_map = IPrincipalRoleMap(obj)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/utils/logger.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/utils/logger.py	(revision 6838)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/utils/logger.py	(revision 6839)
@@ -343,5 +343,5 @@
 
 @grok.subscribe(IDataCenter, IDataCenterStorageMovedEvent)
-def handle_datacenter_storage_move(obj, event):
+def handle_datacenter_storage_moved(obj, event):
     """Event handler, in case datacenter storage moves.
 
@@ -370,5 +370,5 @@
 from waeup.sirp.interfaces import IUniversity
 @grok.subscribe(IUniversity, grok.IObjectRemovedEvent)
-def handle_site_removal(obj, event):
+def handle_site_removed(obj, event):
     collector = queryUtility(ILoggerCollector)
     name = getattr(obj, '__name__', None)